<template>
  <div :class="['post-list', 'post-list--' + this.view]">
    <LoadingSpinner v-if="loading" />
    <div v-if="loaded && posts.length === 0">No posts found.</div>
    <component
      v-for="post in posts"
      :key="post.id"
      :post="post"
      :username="username"
      :alias="postTopicAlias(post)"
      :opUserId="opUserId"
      :view="view"
      :is="itemComponent"
    />
    <PaginationNav
      v-if="showPagination"
      :total="total"
      :offset="offset"
      :limit="limit"
      singular="post"
      plural="posts"
      :omit="['postId']"
    />
  </div>
</template>

<script>
import { ref, computed, onMounted, onUpdated, watch } from 'vue'
import { Fancybox } from '@fancyapps/ui'
import { Constants, VideoHelper, LoadingSpinner, PaginationNav, useApi, useNotification } from '../../core'
import { useAuth } from '../../identity'
import PostsApi from '../api/posts-api.js'
import PostListItemGridview from './post-list-item-gridview.vue'
import PostListItemListview from './post-list-item-listview.vue'

export default {
  name: 'PostList',
  components: {
    LoadingSpinner,
    PaginationNav,
    PostListItemGridview,
    PostListItemListview,
  },
  props: {
    alias: { type: String, default: '' },
    username: { type: String, default: '' },
    offset: { type: Number, default: 0 },
    limit: { type: Number, default: Constants.pagination.defaultPageLimit },
    postId: { type: Number, default: 0 },
    opUserId: { type: Number, default: 0 },
    view: { type: String, default: 'list' }, // 'list', 'list-summary', 'grid'
    route: { type: Object, default: null },
    pagination: { type: Boolean, default: false },
    sort: { type: String, default: 'created' },
  },
  setup(props) {
    const api = useApi()
    const auth = useAuth()
    const notify = useNotification()
    const postsApi = new PostsApi(api, auth)

    const loading = ref(false)
    const loaded = ref(false)
    const hasScrolled = ref(false)
    const posts = ref([])
    const total = ref(0)

    const showPagination = computed(() => {
      return props.pagination && loaded.value && total.value > props.limit
    })

    const itemComponent = computed(() => {
      switch (props.view.toLowerCase()) {
        case 'grid':
          return 'PostListItemGridview'
        default:
          return 'PostListItemListview'
      }
    })

    const loadAsync = async () => {
      loading.value = true
      loaded.value = false
      hasScrolled.value = false
      posts.value = []

      try {
        const response = await postsApi.fetchAsync({
          topic: props.alias,
          username: props.username,
          postId: props.postId,
          expand: 'all',
          offset: props.offset,
          limit: props.limit,
          sort: props.sort,
        })
        total.value = parseInt(response.headers['x-total-count'])
        posts.value = response.data
        loaded.value = true
      } catch (ex) {
        notify.error('There was a problem getting the posts.', ex)
      } finally {
        loading.value = false
      }
    }

    const postTopicAlias = (post) => {
      return post.topic ? post.topic.alias : props.alias
    }

    onMounted(async () => {
      await loadAsync()

      Fancybox.bind('[data-fancybox]', {
        Hash: false,
      })
    })

    onUpdated(() => {
      if (window.location.hash && !hasScrolled.value && loaded.value) {
        VideoHelper.fluidWidth()
        var element = document.querySelector(window.location.hash)
        if (element) {
          element.scrollIntoView()
        }
        hasScrolled.value = true
      }
    })

    watch(
      () => props.offset,
      async () => {
        await loadAsync()
      }
    )

    watch(
      () => props.limit,
      async () => {
        await loadAsync()
      }
    )

    watch(
      () => props.postId,
      async () => {
        await loadAsync()
      }
    )

    return {
      loading,
      loaded,
      hasScrolled,
      posts,
      total,
      showPagination,
      itemComponent,
      postTopicAlias,
    }
  },
}
</script>

<style lang="scss">
@use '../../core/sass/vars';

@media only screen and (min-width: vars.$sm) {
  .post-list--grid {
    display: flex;
    flex-wrap: wrap;
    justify-content: space-between;
  }
}
</style>
